// ENTITYMD2 Class    (c) by Heinrich Tillack 2002
// (c) by Heinrich Tillack 2002 (http://a128.x15.org)
// under GPL or new BSD license



#include "entitymd2.h"
#include <GL/gl.h>
#include <stdio.h>
#include <kos.h>



extern "C" {
	#include "all.h"
}


ENTITY_MD2::ENTITY_MD2(){

    model=NULL;
    tex_id=-1;
}

ENTITY_MD2::~ENTITY_MD2()
{


    if(model!=NULL){
        free_md2(model);

    }

    delete_tex(tex_id) ;
    tex_id=-1;

}

GLvoid ENTITY_MD2::Load(char *model_name, char *skin_name){

    int type;

    DBG("ent.c:load_md2..\n");

    model=load_md2(model_name);

    tex_id=find_tex(skin_name);

    //scan the skin file extension

    char *skin=skin_name;
    // while((char)*skin!=(char)".") skin++;

    if (strcmp(skin,"PCX") || strcmp(skin,"pcx")) type=PCX;
    else if   (strcmp(skin,"JPG") || strcmp(skin,"jpg")) type=JPG;
    else assert_msg(0,"Unsupported texture filetype");

    if(tex_id==-1) {
        int nti=next_tex_id();

        printf("ENTITY_MD2 uses texture Nr.= %d \n",nti);

        if(nti!=-1)
            load_texture(skin_name,nti,type);
        else assert_msg(0,"no free texture available in texture.c");
        tex_id=find_tex(skin_name);

    }


    blendcount=2;

    blendpos=0;
    framenum=1;



}

GLvoid ENTITY_MD2::Draw()
{


    int frame1,frame2;


    if(framenum<anim_start) {
        framenum=anim_start;
    }
    frame1=framenum;
    if(framenum==anim_end) {
        frame2=anim_start;
    } else {
        frame2=framenum+1;
    }

    //if(frame1>(model->framecount-1)) return;
    //if(frame2>(model->framecount-1)) return;
    assert(frame1<=model->framecount);
    assert(frame2<=model->framecount);

    draw_gl_md2(model,tex_id,
                Position.x,Position.y,Position.z,Delta_y,
                frame1,frame2,
                blendpos,blendcount);


    blendpos++;
    if(blendpos>blendcount) {
        blendpos=0;
        framenum++;
    }

    if(framenum>anim_end) { framenum=anim_start; }

}

GLvoid ENTITY_MD2::SetBlendCount(const int b){ blendcount=b;}
GLvoid ENTITY_MD2::SetAnimStart (const int b){anim_start=b;}
GLvoid ENTITY_MD2::SetAnimEnd (const int b){anim_end=b;}
struct md2_model_node *ENTITY_MD2::GetModel(){return model;}



