// OBJECT Class
// (c) by Heinrich Tillack 2002 (http://a128.x15.org)
// based on code by  by Alan Baylis 2001
// under GPL or new BSD license

#ifndef ObjectH
#define ObjectH

#include "matrix.h"
#include "vector.h"
#include "quat.h"
#include <GL/gl.h>



class OBJECT
{
public:
    OBJECT();
    ~OBJECT();



    GLvoid Update();
    GLvoid Apply();

    GLvoid Reset();
    GLvoid Rotate();
    GLvoid Rotate(GLfloat roll, GLfloat pitch, GLfloat yaw);
    GLvoid  Draw();
    GLvoid SetPosition(GLfloat x, GLfloat y, GLfloat z);
    GLvoid GetPosition(GLfloat *x, GLfloat *y, GLfloat *z);
 	GLvoid UpdatePosition();
    GLvoid UpdatePosition(GLfloat x, GLfloat y, GLfloat z);
    GLvoid MoveX();
    GLvoid MoveY();
    GLvoid MoveZ();
    GLvoid MoveX(GLfloat x);
    GLvoid MoveY(GLfloat y);
    GLvoid MoveZ(GLfloat z);
    VECTOR GetXUnit();
    VECTOR GetYUnit();
  	VECTOR GetZUnit();


    VECTOR Position;
    GLfloat Delta_x;   //Rotation deltas
    GLfloat Delta_y;
    GLfloat Delta_z;
    GLfloat Movement_x;    //Movement displacements
    GLfloat Movement_y;
    GLfloat Movement_z;
    GLfloat Multiplier; //FPS values


private:
 // a 4x4 matrix to be used to convert a quaternion to a matrix
	MATRIX Matrix;

	QUAT Orientation;
};

#endif
