
#ifndef planeH
#define planeH

#include "vector.h"

class PLANE
{
public:
	VECTOR N;
	GLfloat	D;

	PLANE(GLfloat A=1, GLfloat B=0, GLfloat C=0, GLfloat D1=0)
	{
			N = VECTOR(A, B, C).GetNormalized();
			D = D1;
	}
	PLANE( VECTOR& Normal, GLfloat D=0) : N(Normal), D(D) { }
	PLANE( PLANE& PLANE) : N(PLANE.N), D(PLANE.D) { }

	PLANE( VECTOR& VertexA, VECTOR& VertexB, VECTOR& VertexC)
	{
		VECTOR NormalA = ((VertexC - VertexA).GetNormalized());
		VECTOR NormalB = ((VertexC - VertexB).GetNormalized());
		D = - VertexA | (N = (NormalA ^ NormalB).GetNormalized());
	}

	PLANE& operator = ( PLANE& PLANE)
	{
		N = PLANE.N;
		D = PLANE.D;
		return *this;
	}

	//	Boolean Operators
	bool operator == ( PLANE& PLANE)
	{
		return N == PLANE.N && D == PLANE.D;
	}
	bool operator != ( PLANE& PLANE)
	{
		return !(*this == PLANE);
	}

	bool PointOnPLANE( VECTOR& Point)
	{
		return DistanceToPLANE(Point) == 0;
	}
	GLfloat DistanceToPLANE( VECTOR& Point)
	{
		return (N | Point) + D;
	}
	VECTOR RayIntersection( VECTOR& RayPos,  VECTOR& RayDir)
	{
		GLfloat a = N | RayDir;
		if (a == 0) return RayPos;	//error line parallel to plane

		return RayPos - RayDir * (DistanceToPLANE(RayPos) / a);
	}


};

#endif

